local dewdrop = DewdropLib:GetInstance("1.0")

local cmdopt = {
	option = "raidwarn",
	desc   = "Options for raidwarning.",
	input  = true,
	args   = {
		{
			option = "toggle",
			desc   = "Toggle the raidwarn module on or off.",
			method = "Toggle",
		},
		{
			option = "broadcast",
			desc   = "Toggle broadcasting on or off.",
			method = "Broadcast",
		},
		{
			option = "whisper",
			desc   = "Toggle whispering on or off.",
			method = "Whisper",
		},
	},
}


BigWigsRaidWarn = AceAddon:new({
	name          = "BigWigsRaidWarn",
	cmd           = AceChatCmd:new({}, {}),
	cmdOptions    = cmdopt,

	loc = {
		menutitle = "Raidwarning",
		menubroadcast = "Broadcast over Raidwarning",
		menuwhisper = "Whisper warnings",
	}
})


function BigWigsRaidWarn:Initialize()
	self:TriggerEvent("BIGWIGS_REGISTER_MODULE", self)
	self.disabled = self:GetOpt("disabled")
end


function BigWigsRaidWarn:Enable()
	self.disabled = nil
	self:RegisterEvent("BIGWIGS_MESSAGE")
	self:RegisterEvent("BIGWIGS_SENDTELL")
end


function BigWigsRaidWarn:Disable()
	self.disabled = true
	self:UnregisterAllEvents()
end

function BigWigsRaidWarn:Toggle()
	local t = self:TogOpt("disabled")
	if t then self:Disable()
	else self:Enable() end
end

function BigWigsRaidWarn:Broadcast()
	local t = self:TogOpt("broadcast")
	self.cmd:result("Broadcasting over RaidWarning is now ".. (t and "ON." or "OFF."))
end

function BigWigsRaidWarn:Whisper()
	local t = self:TogOpt("whisper")
	self.cmd:result("Whispering is now ".. (t and "ON." or "OFF."))
end

function BigWigsRaidWarn:BIGWIGS_MESSAGE(msg, color, noraidsay)
	if( not msg or ( not self:GetOpt("broadcast") ) ) then return end
	if( noraidsay ) then return end
	if( not IsRaidLeader() and not IsRaidOfficer() ) then return end

	SendChatMessage("*** "..msg.." ***", "RAID_WARNING")
end
	
function BigWigsRaidWarn:BIGWIGS_SENDTELL(player, msg)
	if( ( not player ) or ( not msg ) or ( not self:GetOpt("whisper") ) ) then return end
	SendChatMessage(msg, "WHISPER", nil, player)
end

------------------------------
--      Menu Functions      --
------------------------------

function BigWigsRaidWarn:MenuSettings(level, value)
	dewdrop:AddLine("text", self.loc.menubroadcast, "func", self.Broadcast, "arg1", self, "checked", self:GetOpt("broadcast"))
	dewdrop:AddLine("text", self.loc.menuwhisper, "func", self.Whisper, "arg1", self, "checked", self:GetOpt("whisper"))
end


--------------------------------
--      Load this bitch!      --
--------------------------------
BigWigsRaidWarn:RegisterForLoad()
