-- Exploding Labrats
-- made by Merfolk and Awishe
-- Nefarius add counter
-- v. 1.02
--
-- A mod designed to count the number of adds killed at Nefarius phase 1. Certainly makes
-- the tries more interesting since you get direct feedback on how well you did compared to your
-- other tries and helps timing for phase 2. Works only on the range that your combat log registers,
-- though.
--
-- changes:
-- 	1.02
--	  - reset command added so you don't have to reload your ui for every try :)
--	1.01
--	  - made the messages the mod shows a bit more clearer
--	1.0
--	  - initial "release". Not yet even tested with other than the boars and leopards
--	    in front of Ironforge but hopefully it works.
--
-- *************************************************************************

local Nefarius_Announce = false;
local kills = 0;

function Nefarius_OnLoad()
	Sea.IO.print("<Exploding Labrats> Nefarius add counter /Nefarius ON | OFF | RESET");
	SLASH_NEFARIUS1 = "/Nefarius";
	SlashCmdList["NEFARIUS"] = function( msg )
		Nefarius_SlashCommandHandler( msg );
	end
end

function Nefarius_SlashCommandHandler( msg )
	if (string.lower(msg) == "on") then
		Nefarius_Announce = true;

		Nefarius_Register();

		Sea.IO.print("<Exploding Labrats> Nefarius add counter ON");
	elseif (string.lower(msg) == "off") then
		Nefarius_Announce = false;

		Nefarius_Unregister();
		Sea.IO.print("<Exploding Labrats> Nefarius add counter OFF");
	elseif (string.lower(msg) == "reset") then
		kills = 0;
		Sea.IO.print("<Exploding Labrats> Nefarius add counter RESETTED");
	else
		Sea.IO.print("<Exploding Labrats> Nefarius add counter /Nefarius ON | OFF | RESET");
	end
end

function Nefarius_OnEvent(event)
	if   (arg1 == "Black Drakonid dies." or 
		arg1 == "Blue Drakonid dies." or 
		arg1 == "Bronze Drakonid dies." or 
	  	arg1 == "Green Drakonid dies." or 
	  	arg1 == "Red Drakonid dies." or 
	  	arg1 == "Chromatic Drakonid dies.") then
		
		kills = kills + 1
		
		if (Nefarius_Announce) then
			CT_RA_AddMessage("MS Drakonids down: " .. kills .. "");
		end
	end
end

-- *************************************************************************

function Nefarius_Register()
	Nefarius:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH");
end

function Nefarius_Unregister()
	Nefarius:UnregisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH");
end