--[[
	RaidTemplate by Xiven
]]

rt_maxText = 10;
rt_newVersion = "1.0h";

RT_METHOD_SCRAMBLE = 1;
RT_METHOD_TOPTOBOTTOM = 2;


function tellPlayer(msg, name)
	SendChatMessage(msg, "WHISPER", "Common", name);
end

function rt_checkVersion(name)
	tellPlayer("I'm running Raid Template " .. rt_raid["version"], name);
end


function rt_whisper (arg1, name)
	if (not arg1) then
		return;
	end

	if (not name) then
		return;
	end

	arg1 = strlower(arg1);
	if (arg1 == "version") then
		rt_checkVersion(name);
		return;
	end
end


function debugMessage(msg)
	if (not debugger == true) then
		return;
	end;
	displayText(msg);
end

function debugOnce(msg)
	local olddebugger = debugger;
	debugger = true;
	debugMessage(msg);
	debugger = olddebugger;
end



--[[

	local name = "blahblah";
	if (name == "blahblah") then
		debugMessage("name text success");
	end;

	texture1 = getglobal("Spell_Shadow_ShadowWordPain" .. "_" .. "IconTexture");
	if (texture1) then
		debugMessage("got texture " .. texture1);
	else
		debugMessage("1no texture");
	end;

	texture2 = getglobal("Spell_Shadow_ShadowWordPain" .. "IconTexture");
	if (texture2) then
		debugMessage("got texture " .. texture2);
	else
		debugMessage("2no texture");
	end;

	local texture = getglobal("Interface\Icons\Spell_Shadow_ShadowWordPain");
	if (texture) then
		debugMessage("got texture " .. texture);
	else
		debugMessage("3no texture");
	end;
]]



function displayText(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg, pl_cr, pl_cg, pl_cb);
end

function dt(msg)
	displayText(msg);
end

function displayBoolean (msg, boolval)
	if (boolval == true) then
		displayText (msg .. "On");
	else
		displayText (msg .. "Off");
	end	
end

function rt_window_OnDragStart()
	this:StartMoving();
end

function rt_window_OnDragStop()
	this:StopMovingOrSizing();
end

function rt_parent_OnDragStart()
	this:GetParent():StartMoving();
end

function rt_parent_OnDragStop()
	this:GetParent():StopMovingOrSizing();
end

function rt_closeWindow(msg)
	if (msg == "raid") then
		rt_raid["open"] = false;
	end
	
	displayText("Type " .. RAIDTEMPLATE_MACRO_COMMAND .. " to recover window.");
	this:GetParent():Hide();
end

function rt_namelist_closeWindow()
	this:GetParent():Hide();
end


function rt_init()

	SLASH_RAIDTEMPLATE1 = RAIDTEMPLATE_MACRO_COMMAND;
	SlashCmdList["RAIDTEMPLATE"] = function(msg, msg2)
		rt_commands(msg);
	end

	rt_updateFunction = rt_OnUpdate;

	if (not rt_raid) then
		if (xivenTools_raid) then
			displayText("Migrating raid templates from XivenTools to RaidTemplate.");
			rt_raid = xivenTools_raid;
		else
			rt_raid = {};
			rt_raid["size"] = 0;
		end
	end
	
	if (rt_raid["version"] ~= rt_newVersion) then
		displayText("Raid Template is updating to " .. rt_newVersion .. ".");
		rt_raid["version"] = rt_newVersion;

		-- stored so we can do special stuff on a version change if we want to.
	end

	displayText("Raid Template version " .. rt_raid["version"] .. ", by Xiven (avatar@infinityward.com).");
	
	rt_paladinOrShaman = XRT_PALADIN;
	if (UnitFactionGroup("player")) then
		if (UnitFactionGroup("player") == "Horde") then
			rt_paladinOrShaman = XRT_SHAMAN;
		end
	else
		rt_faction = true;
	end
	
	pl_cr = 0.5;
	pl_cg = 0.9;
	pl_cb = 1;

	rt_raidNameSelected = nil;

	local frameCount = 1;
	local evenCountdown = 4;
	frame = getglobal("xivenRaidWindowRaidButton1");
	frame:SetPoint("TOPLEFT", frame:GetParent(), "TOPLEFT", 18, -35);
	frame.raidFunction = raidTemplate_raidButtonPressed;
	local lastframe = frame;
	
	for i=2, 40 do
		local boost = 0;
		frameCount = frameCount + 1;
		if (frameCount > 5) then
			frameCount = 1;
			boost = -10;
		end

		if (i > 5 and evenCountdown == 5) then
			lastframe = getglobal("xivenRaidWindowRaidButton" .. i - 6);
		end

		frame = getglobal("xivenRaidWindowRaidButton" .. i);
		frame.raidFunction = raidTemplate_raidButtonPressed;
		local textframe = getglobal("xivenRaidWindowRaidButton" .. i .. "Class");
		textframe:SetText("");

		if (evenCountdown == 0) then
			evenCountdown = 10;
			local anchorFrame = getglobal("xivenRaidWindowRaidButton" .. i - 5);
			frame:SetPoint("TOPLEFT", anchorFrame, "TOPRIGHT", 0, 0);
		else
			frame:SetPoint("TOPLEFT", lastframe, "BOTTOMLEFT", 0, boost);
		end
		
		lastframe = frame;

		evenCountdown = evenCountdown - 1;
		
		frame:Show();
	end


	

	if (rt_raid["open"] == nil) then
		rt_raid["open"] = true;
	end
	
 	if (not rt_raid["open"]) then
 		xivenRaidWindow:Hide();
	end
	

	lastframe = xivenRaidWindow;
	for i=1, 10 do
		frame = getglobal("xivenRaidWindowRaidName" .. i);
		local textframe = getglobal("xivenRaidWindowRaidName" .. i .. "Text");
		if (rt_raid[i]) then
			textframe:SetText(rt_raid[i]["name"]);
		end

		if (i > 1) then
			frame:SetPoint("TOPLEFT", lastframe, "BOTTOMLEFT", 0, boost);
		end
		lastframe = frame;
	end
	frame = getglobal("xivenRaidWindowRaidName1");
	frame:SetPoint("TOPRIGHT", frame:GetParent(), "TOPRIGHT", -40, -60);


	frame = getglobal("xivenRaidWindowClassName1");
	frame:SetPoint("TOPRIGHT", frame:GetParent(), "TOPRIGHT", -40, -215);
	lastframe = frame;
	
	for i=2, 8 do
		frame = getglobal("xivenRaidWindowClassName" .. i);
		frame:SetPoint("TOPLEFT", lastframe, "BOTTOMLEFT", 0, boost);
		lastframe = frame;
		frame:Show();
	end

-- setup the class priority buttons
	lastframe = xivenRaidWindow;
	for i=1, 20 do
		frame = getglobal("xivenRaidWindow_classPriorityButton" .. i);
		frame.raidFunction = rt_classPriorityButtonPressed;
		local textframe = getglobal("xivenRaidWindow_classPriorityButton" .. i .. "Class");
		textframe:SetText("");

		if (i > 1) then
			frame:SetPoint("TOPLEFT", lastframe, "BOTTOMLEFT", 0, boost);
		end
		lastframe = frame;
		frame:Hide();
	end

	rt_hidePriorityButtons();
		
	frame = getglobal("xivenRaidWindow_classPriorityButton1");
	frame:SetPoint("TOPLEFT", frame:GetParent(), "TOPLEFT", 40, -60);
	local newframe = getglobal("xivenRaidWindow_classText");
	newframe:SetPoint("BOTTOMLEFT", frame, "TOPLEFT", 0, 10);
	newframe:Hide();

	rt_raidNameMenuTop = 1;
	rt_classList = {};
	rt_classListSize = 8;
	rt_classList[1] = XRT_WARRIOR;
	rt_classList[2] = XRT_DRUID;
	rt_classList[3] = XRT_MAGE;
	rt_classList[4] = XRT_WARLOCK;
	rt_classList[5] = XRT_ROGUE;
	rt_classList[6] = XRT_HUNTER;
	rt_classList[7] = XRT_PRIEST;
	rt_classList[8] = rt_paladinOrShaman;
	
	-- setup the class priority list
	if (not rt_raid["classPriority"]) then
		rt_raid["classPriority"] = {};
		for i=1, rt_classListSize do
			rt_raid["classPriority"][rt_classList[i]] = {};
			rt_raid["classPriority"][rt_classList[i]]["size"] = 0;
		end
	end
	rt_insureClassPriorityIncludesFactionalRace();
	
	xivenRaidWindow_RaidChange();
	
	if (rt_raid["class_priority_enabled"] == nil) then
		rt_raid["class_priority_enabled"] = true;
	end

	if (rt_raid["class_priority_index"] == nil) then
		rt_raid["class_priority_index"] = 1;
	end

	
	rt_secondary_class = {};
	rt_secondary_class[XRT_WARRIOR] = XRT_ROGUE;
	rt_secondary_class[XRT_DRUID] = XRT_PRIEST;
	rt_secondary_class[XRT_MAGE] = XRT_WARLOCK;
	rt_secondary_class[XRT_WARLOCK] = XRT_MAGE;
	rt_secondary_class[XRT_ROGUE] = XRT_WARRIOR;
	rt_secondary_class[XRT_HUNTER] = XRT_MAGE;
	rt_secondary_class[XRT_PRIEST] = XRT_DRUID;
	rt_secondary_class[rt_paladinOrShaman] = XRT_DRUID;

	-- adds this much to the score if it uses this class
	rt_secondary_score = {};
	rt_secondary_score[XRT_WARRIOR] = 10;
	rt_secondary_score[XRT_DRUID] = 5;
	rt_secondary_score[XRT_MAGE] = 2;
	rt_secondary_score[XRT_WARLOCK] = 2;
	rt_secondary_score[XRT_ROGUE] = 2;
	rt_secondary_score[XRT_HUNTER] = 2;
	rt_secondary_score[XRT_PRIEST] = 5;
	rt_secondary_score[rt_paladinOrShaman] = 6;
	
	rt_tertiary_class = {};
	rt_tertiary_class[XRT_WARRIOR] = XRT_DRUID;
	rt_tertiary_class[XRT_DRUID] = rt_paladinOrShaman;
	rt_tertiary_class[XRT_MAGE] = XRT_HUNTER;
	rt_tertiary_class[XRT_WARLOCK] = XRT_HUNTER;
	rt_tertiary_class[XRT_ROGUE] = XRT_WARLOCK;
	rt_tertiary_class[XRT_HUNTER] = XRT_ROGUE;
	rt_tertiary_class[XRT_PRIEST] = rt_paladinOrShaman;
	rt_tertiary_class[rt_paladinOrShaman] = XRT_PRIEST;

	rt_tertiary_score = {};
	rt_tertiary_score[XRT_WARRIOR] = 15;
	rt_tertiary_score[XRT_DRUID] = 10;
	rt_tertiary_score[XRT_MAGE] = 2;
	rt_tertiary_score[XRT_WARLOCK] = 2;
	rt_tertiary_score[XRT_ROGUE] = 10;
	rt_tertiary_score[XRT_HUNTER] = 8;
	rt_tertiary_score[XRT_PRIEST] = 18;
	rt_tertiary_score[rt_paladinOrShaman] = 14;

	rt_withAnybody_score = {};
	rt_withAnybody_score[XRT_WARRIOR] = 35;
	rt_withAnybody_score[XRT_DRUID] = 50;
	rt_withAnybody_score[XRT_MAGE] = 15;
	rt_withAnybody_score[XRT_WARLOCK] = 15;
	rt_withAnybody_score[XRT_ROGUE] = 15;
	rt_withAnybody_score[XRT_HUNTER] = 15;
	rt_withAnybody_score[XRT_PRIEST] = 50;
	rt_withAnybody_score[rt_paladinOrShaman] = 35;

	local colors = rt_getClassColors();	
	
	for i=1, rt_classListSize do
		local textframe = getglobal("xivenRaidWindowClassName" .. i .. "Text");
		textframe:SetText(rt_classList[i]);
		textframe:SetTextColor(colors[rt_classList[i]][1], colors[rt_classList[i]][2], colors[rt_classList[i]][3]);
	end
	
	local offset = 8;
	frame = getglobal("xivenRaidWindowApplyButton");
	frame:SetPoint("TOPRIGHT", getglobal("xivenRaidWindowClassName8"), "BOTTOMRIGHT", offset * -1, -5);

	frame = getglobal("xivenRaidWindowPriorityButton");
	frame:SetPoint("TOPLEFT", getglobal("xivenRaidWindowClassName8"), "BOTTOMLEFT", offset, -5);

	if (not rt_raid["method"]) then
		rt_raid["method"] = RT_METHOD_TOPTOBOTTOM;
	end
	

	local lastFrame = getglobal("xivenRaidWindow");
	for i=1, 2 do
		frame = getglobal("xivenRaidWindow_raidmethod" .. i);
		if (i > 1) then
			frame:SetPoint("LEFT", lastFrame, "RIGHT", 80, 0);
		else
			frame:SetPoint("BOTTOMLEFT", lastFrame, "BOTTOMLEFT", 15, 5);
		end
	
		local textframe = getglobal(frame:GetName() .. "MethodText");
		if (i==1) then
			textframe:SetText("Scramble");
		end
		if (i==2) then
			textframe:SetText("Top to Bottom");
		end
		
		if (i == rt_raid["method"]) then
			frame:SetChecked(1);
		else	
			frame:SetChecked(0);
		end
		lastFrame = frame;
	end
	
	UIDropDownMenu_Initialize(RIGroupOrderDropDown, RIGroupOrderDropDown_Initialize);
	
end

function rt_priorityButtonPressed()
	local frame = 0;
	
	if (this:GetText() == "Priority") then
		for i=1, 40 do
			frame = getglobal("xivenRaidWindowRaidButton" .. i);
			frame:Hide();
		end
		for i=1, 20 do
			frame = getglobal("xivenRaidWindow_classPriorityButton" .. i);
			frame:Show();
		end
		rt_updateClassPriorityButtons();
		this:SetText("Back");
		rt_showPriorityButtons();
	else

		for i=1, 40 do
			frame = getglobal("xivenRaidWindowRaidButton" .. i);
			frame:Show();
		end
		for i=1, 20 do
			frame = getglobal("xivenRaidWindow_classPriorityButton" .. i);
			frame:Hide();
		end
		
		rt_hidePriorityButtons();
		this:SetText("Priority");
	end
end


function fakeGroups(rt_classes)
	
	for i=1, rt_classListSize do
		rt_classes[rt_classList[i]] = {};
		rt_classes[rt_classList[i]]["size"] = 0;
	end
	
	rt_classes = rt_addClass(rt_classes, XRT_WARRIOR, "Asumasensei", 1);
	rt_classes = rt_addClass(rt_classes, XRT_WARRIOR, "Ronyar", 2);
	rt_classes = rt_addClass(rt_classes, XRT_WARRIOR, "Vivisonia", 3);
	rt_classes = rt_addClass(rt_classes, XRT_WARRIOR, "Khurran", 25);
	rt_classes = rt_addClass(rt_classes, XRT_WARRIOR, "Lawiez", 26);
	--[[
	rt_classes = rt_addClass(rt_classes, XRT_WARRIOR, "Ronyar", 14);
	rt_classes = rt_addClass(rt_classes, XRT_WARRIOR, "Vivisonia", 15);
	rt_classes = rt_addClass(rt_classes, XRT_WARRIOR, "Khurran", 33);
	rt_classes = rt_addClass(rt_classes, XRT_WARRIOR, "Lawiez", 34);
	]]
	
	rt_classes = rt_addClass(rt_classes, XRT_WARLOCK, "Snifflez", 4);
	rt_classes = rt_addClass(rt_classes, XRT_WARLOCK, "Hehx", 5);
	rt_classes = rt_addClass(rt_classes, XRT_WARLOCK, "Door", 6);
	rt_classes = rt_addClass(rt_classes, XRT_WARLOCK, "Ristretto", 27);
	rt_classes = rt_addClass(rt_classes, XRT_WARLOCK, "Deveus", 28);
	
	rt_classes = rt_addClass(rt_classes, XRT_PRIEST, "Xiven", 7);
	rt_classes = rt_addClass(rt_classes, XRT_PRIEST, "Gentho", 8);
	rt_classes = rt_addClass(rt_classes, XRT_PRIEST, "Shadowheal", 9);
	rt_classes = rt_addClass(rt_classes, XRT_PRIEST, "Ilovetea", 29);
	rt_classes = rt_addClass(rt_classes, XRT_PRIEST, "Earltea", 30);
	
	rt_classes = rt_addClass(rt_classes, XRT_MAGE, "Avarim", 10);
	rt_classes = rt_addClass(rt_classes, XRT_MAGE, "Ralan", 11);
	rt_classes = rt_addClass(rt_classes, XRT_MAGE, "Shotte", 12);
	rt_classes = rt_addClass(rt_classes, XRT_MAGE, "Firebat", 31);
	rt_classes = rt_addClass(rt_classes, XRT_MAGE, "Luffy", 32);
	
	rt_classes = rt_addClass(rt_classes, XRT_ROGUE, "Caritchril", 13);
	rt_classes = rt_addClass(rt_classes, XRT_ROGUE, "Eggdrop", 14);
	rt_classes = rt_addClass(rt_classes, XRT_ROGUE, "Pokinatcha", 15);
	rt_classes = rt_addClass(rt_classes, XRT_ROGUE, "Larby", 33);
	rt_classes = rt_addClass(rt_classes, XRT_ROGUE, "Tens", 34);
	
	rt_classes = rt_addClass(rt_classes, XRT_HUNTER, "Beral", 16);
	rt_classes = rt_addClass(rt_classes, XRT_HUNTER, "Saithis", 17);
	rt_classes = rt_addClass(rt_classes, XRT_HUNTER, "Zedleppelin", 18);
	rt_classes = rt_addClass(rt_classes, XRT_HUNTER, "Volva", 35);
	rt_classes = rt_addClass(rt_classes, XRT_HUNTER, "Shokisan", 36);
	
	rt_classes = rt_addClass(rt_classes, XRT_DRUID, "Noele", 19);
	rt_classes = rt_addClass(rt_classes, XRT_DRUID, "Lamoon", 20);
	rt_classes = rt_addClass(rt_classes, XRT_DRUID, "Stormed", 21);
	rt_classes = rt_addClass(rt_classes, XRT_DRUID, "Savagekiller", 37);
	rt_classes = rt_addClass(rt_classes, XRT_DRUID, "Delenn", 38);
	
	rt_classes = rt_addClass(rt_classes, rt_paladinOrShaman, "Harnet", 22);
	rt_classes = rt_addClass(rt_classes, rt_paladinOrShaman, "Isorion", 23);
	rt_classes = rt_addClass(rt_classes, rt_paladinOrShaman, "Jeramais", 24);
	rt_classes = rt_addClass(rt_classes, rt_paladinOrShaman, "Zaeroboy", 39);
	rt_classes = rt_addClass(rt_classes, rt_paladinOrShaman, "Goldenhand", 40);
	return rt_classes;
end

function rt_applyButtonPressed()
	--[[
		Original method
		Try exact matches on first 2 groups
		Then do the other 6 in order of group construction, 1 through 5
		Then more passes with secondary and tertiary choices
	]]

	debugMessage(" ");
	debugMessage(" ");
		
	if (not rt_raidNameSelected) then
		return;
	end
	
	local raidCount = GetNumRaidMembers();
	rt_classes = {};
	
	for i=1, rt_classListSize do
		rt_classes[rt_classList[i]] = {};
		rt_classes[rt_classList[i]]["size"] = 0;
	end


	rt_classPriorityArray = {};
	
	for i = 1, raidCount do
		local name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
		local index = rt_classes[class]["size"] + 1;
		rt_classPriorityArray[name] = true;
		rt_classes[class]["size"] = index;
		rt_classes[class][index] = {};
		rt_classes[class][index]["name"] = name;
		rt_classes[class][index]["group"] = subgroup;
		rt_classes[class][index]["class"] = class;
		rt_classes[class][index]["index"] = i;
--		displayText(i .. " name: " .. name .. "  class:" .. class .. "  subgroup: " .. subgroup);

	end	

--	rt_classes = fakeGroups(rt_classes);
--[[
	rt_classes[XRT_ROGUE]["size"] = 3;
	rt_classes[XRT_WARRIOR]["size"] = 9;
	rt_classes[XRT_PRIEST]["size"] = 3;
]]

	local numGroups = 0;
	local raidCountNum = 0;
	for i=1, rt_classListSize do
		raidCountNum = raidCountNum + rt_classes[rt_classList[i]]["size"];
	end
	
	while (raidCountNum > 0) do
		numGroups = numGroups + 1;
		raidCountNum = raidCountNum - 5;
	end

	if (numGroups < 2) then
		displayText("Requires at least 2 groups worth of people!");
		return;
	end	
	
	rt_raidResults = {};
	rt_raidResults["size"] = 0;

	local originalOrder = {};
	originalOrder["size"] = 0;
	for z=1, numGroups-1 do
		for i=1, 5 do
			--[[
			if (originalOrder["size"] + 1 > raidCount) then
				break;
			end
			]]
			
			originalOrder["size"] = originalOrder["size"] + 1;
			originalOrder[originalOrder["size"]] = {};
			originalOrder[originalOrder["size"]]["group"] = z;
			originalOrder[originalOrder["size"]]["slot"] = i;
--			displayText("Raid order " .. originalOrder["size"] .. " is group " .. z .. " and slot " .. i);
		end
	end


	local raidTotal = raidCount - (numGroups-1)*5;
--	displayText("raid total " .. raidTotal);
	local originalSlots = {};
	for i=1, 5 do
		originalSlots[i] = i;
	end
	
	if (rt_raid["method"] == RT_METHOD_SCRAMBLE) then
		
		for p = 1, 500 do
			-- we'll temporarily place the players in this array
			rt_raidGroups = {};
			for i = 1, numGroups do
				rt_raidGroups[i] = {};
			end
	--		displayText("      ");
	--		displayText("attempt " .. p);
			
			local raidOrder = originalOrder;
			local newSlots = rt_scrambleArray(originalSlots);
			
			for i=1, raidTotal do
				--[[
				if (raidOrder["size"] + 1 > raidCount) then
					break;
				end
				]]
				
				raidOrder["size"] = raidOrder["size"] + 1;
				raidOrder[raidOrder["size"]] = {};
				raidOrder[raidOrder["size"]]["group"] = numGroups;
				raidOrder[raidOrder["size"]]["slot"] = newSlots[i];
	--			displayText("Raid order " .. raidOrder["size"] .. " is group " .. z .. " and slot " .. i);
			end
			raidOrder = rt_scrambleRaid(raidOrder);
			
			local exacts = 0;
			local seconds = 0;
			local thirds = 0;
			local anys = 0;
			local score = 0;
			local filled = {};
		
			for i=1, rt_classListSize do
				for z=1, rt_classes[rt_classList[i]]["size"] do
					rt_classes[rt_classList[i]][z]["used"] = nil;
				end
			end
			

			
	--		testvar = raidOrder;
			if (not rt_classPriority()) then
				for i=1, raidOrder["size"] do
					if (rt_tryToFillSpotWithNames(raidOrder[i]["group"], raidOrder[i]["slot"])) then
						exacts = exacts + 1;
						filled[i] = true;
					end
				end
			end
			for i=1, raidOrder["size"] do
	--			displayText("group " .. raidOrder[i]["group"] .. " and slot " .. raidOrder[i]["slot"]);
				if (rt_tryToFillSpotExactly(raidOrder[i]["group"], raidOrder[i]["slot"])) then
	--				displayText("found exact match");
					exacts = exacts + 1;
					filled[i] = true;
				end
			end
			for i=1, raidOrder["size"] do
	--			displayText("group " .. raidOrder[i]["group"] .. " and slot " .. raidOrder[i]["slot"]);
	--			displayText("executing raid order " .. i);
				if (not filled[i]) then
					if (rt_tryToFillSpotSecondary(raidOrder[i]["group"], raidOrder[i]["slot"])) then
						seconds = seconds + 1;
						score = score + rt_secondary_score[rt_raidGroups[raidOrder[i]["group"]][raidOrder[i]["slot"]]["class"]];
					else
						if (rt_tryToFillSpotTertiary(raidOrder[i]["group"], raidOrder[i]["slot"])) then
							thirds = thirds + 1;
							score = score + rt_tertiary_score[rt_raidGroups[raidOrder[i]["group"]][raidOrder[i]["slot"]]["class"]];
						else
							if (rt_tryToFillSpotWithAnything(raidOrder[i]["group"], raidOrder[i]["slot"])) then
								anys = anys + 1;
								score = score + rt_withAnybody_score[rt_raidGroups[raidOrder[i]["group"]][raidOrder[i]["slot"]]["class"]];
							end
						end
					end
				end
			end
			
			local index = rt_raidResults["size"] + 1;
			rt_raidResults["size"] = index;
			rt_raidResults[index] = {};
			rt_raidResults[index]["raid"] = rt_raidGroups;
			rt_raidResults[index]["score"] = score;
			rt_raidResults[index]["01"] = exacts;
			rt_raidResults[index]["02"] = seconds;
			rt_raidResults[index]["03"] = thirds;
			rt_raidResults[index]["04"] = anys;
		end
	end
	
	if (rt_raid["method"] == RT_METHOD_TOPTOBOTTOM) then
		for i=1, 5 do
			originalSlots[i] = i;
		end
		
		-- we'll temporarily place the players in this array
		rt_raidGroups = {};
		for i = 1, numGroups do
			rt_raidGroups[i] = {};
		end
--		displayText("      ");
--		displayText("attempt " .. p);
		
		local raidOrder = originalOrder;
		local newSlots = rt_scrambleArray(originalSlots);
		
		for i=1, 5 do
			--[[
			if (raidOrder["size"] + 1 > raidCount) then
				break;
			end
			]]
			
			raidOrder["size"] = raidOrder["size"] + 1;
			raidOrder[raidOrder["size"]] = {};
			raidOrder[raidOrder["size"]]["group"] = numGroups;
			raidOrder[raidOrder["size"]]["slot"] = i;
--			displayText("Raid order " .. raidOrder["size"] .. " is group " .. z .. " and slot " .. i);
		end
		
		local exacts = 0;
		local seconds = 0;
		local thirds = 0;
		local anys = 0;
		local score = 0;
		local filled = {};
	
		for i=1, rt_classListSize do
			for z=1, rt_classes[rt_classList[i]]["size"] do
				rt_classes[rt_classList[i]][z]["used"] = nil;
			end
		end
		

		
		if (not rt_classPriority()) then
			for i=1, raidOrder["size"] do
				if (rt_tryToFillSpotWithNames(raidOrder[i]["group"], raidOrder[i]["slot"])) then
					debugMessage("filled with name!");
					exacts = exacts + 1;
					filled[i] = true;
				end
			end
		else
			for i=1, raidOrder["size"] do
--				debugMessage("filling class priority slot " .. raidOrder[i]["group"] .. " " ..  raidOrder[i]["slot"]);
				if (rt_tryToFillSpotWithClassPriority(raidOrder[i]["group"], raidOrder[i]["slot"])) then
					exacts = exacts + 1;
					filled[i] = true;
				end
			end
		end
		
		for i=1, raidOrder["size"] do
--			displayText("group " .. raidOrder[i]["group"] .. " and slot " .. raidOrder[i]["slot"]);
			if (rt_tryToFillSpotExactly(raidOrder[i]["group"], raidOrder[i]["slot"])) then
--				displayText("found exact match");
				exacts = exacts + 1;
				filled[i] = true;
			end
		end
		for i=1, raidOrder["size"] do
--			displayText("group " .. raidOrder[i]["group"] .. " and slot " .. raidOrder[i]["slot"]);
--			displayText("executing raid order " .. i);
			if (not filled[i]) then
				if (rt_tryToFillSpotSecondary(raidOrder[i]["group"], raidOrder[i]["slot"])) then
					seconds = seconds + 1;
					score = score + rt_secondary_score[rt_raidGroups[raidOrder[i]["group"]][raidOrder[i]["slot"]]["class"]];
				else
					if (rt_tryToFillSpotTertiary(raidOrder[i]["group"], raidOrder[i]["slot"])) then
						thirds = thirds + 1;
						score = score + rt_tertiary_score[rt_raidGroups[raidOrder[i]["group"]][raidOrder[i]["slot"]]["class"]];
					else
						if (rt_tryToFillSpotWithAnything(raidOrder[i]["group"], raidOrder[i]["slot"])) then
							anys = anys + 1;
							score = score + rt_withAnybody_score[rt_raidGroups[raidOrder[i]["group"]][raidOrder[i]["slot"]]["class"]];
						end
					end
				end
			end
		end
		
		local index = rt_raidResults["size"] + 1;
		rt_raidResults["size"] = index;
		rt_raidResults[index] = {};
		rt_raidResults[index]["raid"] = rt_raidGroups;
		rt_raidResults[index]["score"] = score;
		rt_raidResults[index]["01"] = exacts;
		rt_raidResults[index]["02"] = seconds;
		rt_raidResults[index]["03"] = thirds;
		rt_raidResults[index]["04"] = anys;
	end
	
		
--	rt_raidResults = rt_reorgArrayInOrderOfScore(rt_raidResults);
	rt_raidResults = rt_lowestScoreInArray(rt_raidResults);
	
	
	testvar = rt_raidResults;
	displayText("The combination chosen had a score of " .. rt_raidResults["score"] .. " (lower is better).");
	displayText(rt_raidResults["01"] .. " exact matches.");
	displayText(rt_raidResults["02"] .. " second choices.");
	displayText(rt_raidResults["03"] .. " third choices.");
	displayText(rt_raidResults["04"] .. " fourth choices. (Fourth choices are bad)");
--	testvar = rt_raid;
	
	--[[
	for i=1, numGroups do
		for p=1, 5 do
			if (rt_raidResults["raid"][i] and rt_raidResults["raid"][i][p]) then
				displayText("Group " .. i .. " slot " .. p .. " class " .. rt_raidResults["raid"][i][p]["class"] .. " and name " .. rt_raidResults["raid"][i][p]["name"]);
			end
		end
	end
	]]
	
	for i=1, numGroups do
		for p=1, 5 do
--			displayText("trying group " .. i .. " slot " .. p);
			local breaker = 0;
			while (1) do
				breaker = breaker + 1;
				if (not rt_fillSlotWithPlayerThatShouldBeMovedToThisGroup( i, p ) or breaker > 20) then
					break;
				end
				break;
			end
		end
	end
	
end

function rt_fillSlotWithPlayerThatShouldBeMovedToThisGroup( group, slot )
	if (not rt_raidResults["raid"][group] or not rt_raidResults["raid"][group][slot]) then
		debugMessage("nobody in group " .. group .. " slot " .. slot);
		return nil;
	end
	if (rt_raidResults["raid"][group][slot]["desired_group"] == rt_raidResults["raid"][group][slot]["group"]) then
		-- we're already in the correct group
		debugMessage(rt_raidResults["raid"][group][slot]["name"] .. " is already in the right group (" .. rt_raidResults["raid"][group][slot]["desired_group"] .. ")");
		return nil;
	end

	-- find a player that is in the group we want to get in	
	for i = 1, 8 do
		for p = 1, 5 do
			if (rt_raidResults["raid"][i] and rt_raidResults["raid"][i][p] and rt_raidResults["raid"][i][p]["group"] == group and rt_raidResults["raid"][i][p]["desired_group"] ~= rt_raidResults["raid"][group][slot]["desired_group"]) then
				debugMessage("swapping " .. rt_raidResults["raid"][group][slot]["name"] .. " from group " .. rt_raidResults["raid"][group][slot]["group"] .. " and " .. rt_raidResults["raid"][i][p]["name"] .. " from group " .. rt_raidResults["raid"][i][p]["group"] .. ", desired group is " .. group .. " or " .. rt_raidResults["raid"][group][slot]["desired_group"]);
				-- swap the players
--[[
				local tempPlayer = rt_raidResults["raid"][i][p];
				rt_raidResults["raid"][i][p] = rt_raidResults["raid"][group][slot];
				rt_raidResults["raid"][group][slot] = tempPlayer;
]]

				-- swap their groups
				local tempGroup = rt_raidResults["raid"][i][p]["group"];
				rt_raidResults["raid"][i][p]["group"] = rt_raidResults["raid"][group][slot]["group"];
				rt_raidResults["raid"][group][slot]["group"] = tempGroup;

				-- do the actual swap
				SwapRaidSubgroup(rt_raidResults["raid"][i][p]["index"], rt_raidResults["raid"][group][slot]["index"]);
--				displayText(rt_raidResults["raid"][group][slot]["name"] .. " is now in group " .. rt_raidResults["raid"][group][slot]["group"]);
--				displayText(rt_raidResults["raid"][i][p]["name"] .. " is now in group " .. rt_raidResults["raid"][i][p]["group"]);
				return true;
			end
		end
	end

	debugMessage("Moved " .. rt_raidResults["raid"][group][slot]["name"] .. " into group " .. rt_raidResults["raid"][group][slot]["desired_group"]);
	-- if we cant find anybody to switch with, we just set group directly
	SetRaidSubgroup(rt_raidResults["raid"][group][slot]["index"], rt_raidResults["raid"][group][slot]["desired_group"]);
	rt_raidResults["raid"][group][slot]["group"] = rt_raidResults["raid"][group][slot]["desired_group"];
	return nil;
end


function rt_reorgArrayInOrderOfScore(array)
	local completed = {};
	local newArray = {};
	newArray["size"] = 0;
	for i=1, array["size"] do
		local index = -1;
		local score = 5000;
		for p=1, array["size"] do
			if (not completed[p]) then
				if (array[p]["score"] < score) then
					score = array[p]["score"];
					index = p;
				end
			end
		end
		
		if (index ~= -1) then
			newArray["size"] = newArray["size"] + 1;
			newArray[newArray["size"]] = array[index];
			completed[index] = true;
		end
	end
	
	displayText("returned array of size " .. newArray["size"]);
	return newArray;
end

function rt_lowestScoreInArray(array)
	local index = -1;
	local score = 5000;
	for p=1, array["size"] do
		if (array[p]["score"] < score) then
			score = array[p]["score"];
			index = p;
		end
	end
	
	if (index ~= -1) then
		return array[index];
	end
	return nil;
end

function rt_scrambleRaid(raidOrder)
	for i=1, raidOrder["size"] do
		local tempRaid = raidOrder[i];
		local randNum = math.random(1,raidOrder["size"]);
		raidOrder[i] = raidOrder[randNum];
		raidOrder[randNum] = tempRaid;
	end

	return raidOrder;
end

function rt_tryToFillGroupExactly(group)
	for i=1, 5 do
		rt_tryToFillSpotExactly(group, i);
	end
end

function rt_filledSpotPrint(group, slot, class, attempt)
	displayText(group .. " " .. slot .. " " .. class .. " " .. attempt);
end

function rt_fillSpotWithClass(class, group, slot, attempt)
--	displayText("Filling group " .. group .. " slot " .. slot .. " with class " .. class);
	if (rt_raidGroups[group][slot]) then
--		displayText("this group and slot is already filled");
		return nil;
	end
	
--	displayText("size of the class is " .. rt_classes[class]["size"]);
	-- first try to find somebody that is already in the group	
	for i=1, rt_classes[class]["size"]  do
		if (not rt_classes[class][i]["used"] and rt_classes[class][i]["group"] == group) then
			rt_classes[class][i]["used"] = true;
			rt_raidGroups[group][slot] = rt_addRaidSlotToGroups(class, i, group);
--			rt_filledSpotPrint(group, slot, class, attempt);
			return true;
		end
	end
	
	for i=1, rt_classes[class]["size"]  do
		if (not rt_classes[class][i]["used"]) then
			rt_classes[class][i]["used"] = true;
			rt_raidGroups[group][slot] = rt_addRaidSlotToGroups(class, i, group);
--			rt_filledSpotPrint(group, slot, class, attempt);
			return true;
		end
	end
	return nil;
end

function rt_fillSpotWithName(name, group, slot, attempt)
--	displayText("Filling group " .. group .. " slot " .. slot .. " with name " .. name);
	if (rt_raidGroups[group][slot]) then
--		displayText("this group and slot is already filled");
		return nil;
	end
	
	for p=1, 8 do
		for i=1, rt_classes[rt_classList[p]]["size"]  do
			if (not rt_classes[rt_classList[p]][i]["used"] and rt_classes[rt_classList[p]][i]["name"] == name) then
				debugMessage("putting " .. name .. " into group " .. group);
				rt_classes[rt_classList[p]][i]["used"] = true;
				rt_raidGroups[group][slot] = rt_addRaidSlotToGroups(rt_classList[p], i, group);
				return true;
			end
		end
	end
	return nil;
end


function rt_addRaidSlotToGroups(class, index, group)
	local array = {};
	array["class"] = rt_classes[class][index]["class"];
	array["name"] = rt_classes[class][index]["name"];
	array["index"] = rt_classes[class][index]["index"];
	array["group"] = rt_classes[class][index]["group"];
	array["desired_group"] = group;
	return array;	
end

function rt_tryToFillSpotWithNames(group, slot)
	local name = rt_getName(group,slot);
	if (name) then
		debugMessage("Trying to fill group " .. group .. " slot " .. slot .. " with " .. name);
		return rt_fillSpotWithName(name, group, slot, "Exactly");
	end
end

function rt_tryToFillSpotWithClassPriority(group, slot)
	local class = rt_getClass(group, slot);
	for i=1, rt_raid["classPriority"][class]["size"] do
		
		if (rt_classPriorityArray[rt_raid["classPriority"][class][i]]) then
			local name = rt_raid["classPriority"][class][i];
			if (group == 1) then
				debugMessage("trying " .. rt_raid["classPriority"][class][i]);
--				displayText("name is " .. name);
			end
			
			if (rt_fillSpotWithName(name, group, slot, "Exactly")) then
				rt_classPriorityArray[rt_raid["classPriority"][class][i]] = nil;
				debugMessage("filled " .. group .. " " .. slot .. " with " .. name);
				return true;	
			end
		end
	end
	return false;
end

function rt_tryToFillSpotExactly(group, slot)
--	displayText("groupslot " .. group .. " " .. slot);
	
	local class = rt_getClass(group, slot);
	if (not class) then
		return nil;
	end
--	displayText(" 1st Trying to fill a " .. class .. " spot exactly");
	return rt_fillSpotWithClass(class, group, slot, "Exactly");
end

function rt_tryToFillGroupSecondary(group)
	for i=1, 5 do
		rt_tryToFillSpotSecondary(group, i);
	end
end

function rt_tryToFillSpotSecondary(group, slot)
	local class = rt_getClass(group, slot);
	if (not class) then
		return nil;
	end
	
--	displayText(group .. " " .. slot .. " 2nd Trying to fill a " .. class .. " spot with " .. rt_secondary_class[class]);
	class = rt_secondary_class[class];
	return rt_fillSpotWithClass(class, group, slot, "Secondary");
end

function rt_tryToFillGroupTertiary(group)
	for i=1, 5 do
		rt_tryToFillSpotTertiary(group, i);
	end
end

function rt_tryToFillSpotTertiary(group, slot)
	local class = rt_getClass(group, slot);
	if (not class) then
		return nil;
	end
	
--	displayText(group .. " " .. slot .. " 3rd Trying to fill a " .. class .. " spot with " .. rt_secondary_class[class]);
	class = rt_tertiary_class[class];
	return rt_fillSpotWithClass(class, group, slot, "Tertiary");
end

function rt_tryToFillGroupWithAnything(group)
	for i=1, 5 do
		rt_tryToFillSpotWithAnything(group, i);
	end
end

function rt_tryToFillSpotWithAnything(group, slot)
	if (rt_raidGroups[group][slot]) then
		return;
	end

	for i=1, 8 do
		if (rt_filledSpotWithClass(rt_classList[i], group, slot)) then
--			rt_filledSpotPrint(group, slot, rt_classList[i], "Anything");
			return true;
		end
	end
	return nil;
end

function rt_getClass(group, slot)
	if (not rt_raid[rt_raidNameSelected][(group-1)*5 + slot]) then
		return nil;
	end
	if (not rt_raid[rt_raidNameSelected][(group-1)*5 + slot]["class"]) then
		return nil;
	end
	
	return rt_raid[rt_raidNameSelected][(group-1)*5 + slot]["class"];
end

function rt_getName(group, slot)
	if (not rt_raid[rt_raidNameSelected][(group-1)*5 + slot]) then
		return nil;
	end
	if (not rt_raid[rt_raidNameSelected][(group-1)*5 + slot]["name"]) then
		return nil;
	end
	
	return rt_raid[rt_raidNameSelected][(group-1)*5 + slot]["name"];
end

function rt_filledSpotWithClass(class, group, slot)
	for i=1, rt_classes[class]["size"]  do
		if (not rt_classes[class][i]["used"]) then
			rt_classes[class][i]["used"] = true;
			rt_raidGroups[group][slot] = rt_addRaidSlotToGroups(class, i, group);
			return true;
		end
	end
	return nil;
end


function rt_getClassColors()
	local colors = {};
	colors = rt_setColor( colors, XRT_WARRIOR, 0.78, 0.61, 0.43 );
	colors = rt_setColor( colors, XRT_DRUID, 1.0, 0.49, 0.04 );
	colors = rt_setColor( colors, XRT_MAGE, 0.41, 0.8, 0.94 );
	colors = rt_setColor( colors, XRT_WARLOCK, 0.58, 0.51, 0.79 );
	colors = rt_setColor( colors, XRT_ROGUE, 1.0, 0.96, 0.41 );
	colors = rt_setColor( colors, XRT_HUNTER, 0.67, 0.83, 0.45 );
	colors = rt_setColor( colors, XRT_PRIEST, 1.0, 1.0, 1.0 );
	colors = rt_setColor( colors, rt_paladinOrShaman, 0.96, 0.55, 0.73 );
	return colors;
end

function rt_raidNameButtonPressed()
	if (this:GetID() + rt_raidNameMenuTop - 1 > rt_raid["size"]) then
		return;
	end
	
	if (getglobal("xivenRaidWindowPriorityButton"):GetText() == "Back") then
		-- switch back to the raid menu
		rt_priorityButtonPressed();
	end
	
	rt_raidNameSelected = this:GetID() + rt_raidNameMenuTop - 1;
	if (rt_raidNameSelected > rt_raid["size"]) then
		rt_raidNameSelected = nil;
	end
	rt_updateRaidNameList();
	rt_updateRaid();
	
end

function rt_classButtonPressed()
	rt_selectedClass = rt_classList[this:GetID()];
	getglobal("xivenRaidWindow_classText"):SetText(rt_selectedClass .. " Priority");
	rt_updateClassList();
	rt_updateClassPriorityButtons();
end

function rt_raidButtonPressed()
	this.raidFunction();
end

function raidTemplate_raidButtonPressed()
	if (not rt_selectedClass) then
		return;
	end;

	if (not rt_raidNameSelected) then
		return;
	end
	
	rt_raid[rt_raidNameSelected][this:GetID()]["class"] = rt_selectedClass;
	rt_raid[rt_raidNameSelected][this:GetID()]["name"] = nil;
	rt_updateRaid();
end

function rt_updateClassList()
	local colors = rt_getClassColors();	
	for i=1, rt_classListSize do
		local textframe = getglobal("xivenRaidWindowClassName" .. i .. "Text");
		if (rt_selectedClass and rt_selectedClass == textframe:GetText()) then
			textframe:SetTextColor(0, 1, 0);
		else
			textframe:SetTextColor(colors[rt_classList[i]][1], colors[rt_classList[i]][2], colors[rt_classList[i]][3]);
		end
	end
end


function rt_updateRaid()
	if (not rt_raidNameSelected) then
		rt_clearRaid();
		return;
	end
	
	local colors = rt_getClassColors();	
--	displayText("selected raid is " .. rt_raidNameSelected);
	for i=1, rt_raid[rt_raidNameSelected]["raidsize"] do
		local frame = getglobal("xivenRaidWindowRaidButton" .. i .. "Class");
		if (not rt_classPriority() and rt_raid[rt_raidNameSelected][i]["name"]) then
			frame:SetText(rt_raid[rt_raidNameSelected][i]["name"]);
		else
			frame:SetText(rt_raid[rt_raidNameSelected][i]["class"]);
		end

		frame:SetTextColor(colors[rt_raid[rt_raidNameSelected][i]["class"]][1], colors[rt_raid[rt_raidNameSelected][i]["class"]][2], colors[rt_raid[rt_raidNameSelected][i]["class"]][3]);
	end
end

function rt_clearRaid()
	for i=1, 40 do
		local frame = getglobal("xivenRaidWindowRaidButton" .. i .. "Class");
		frame:SetText("");
	end
	getglobal("xivenRaidWindowRaidName"):SetText("");
end

function rt_deleteRaid()
	rt_raidEscapePressed();

	if (not rt_raidNameSelected) then
		return;
	end
	
	for i=rt_raidNameSelected, rt_raid["size"] - 1 do
		rt_raid[i] = rt_raid[i + 1];
	end

	rt_raid[rt_raid["size"]] = {};
	rt_raid["size"] = rt_raid["size"] - 1;
	if (rt_raidNameSelected > rt_raid["size"]) then
		rt_raidNameSelected = rt_raid["size"];
		if (rt_raidNameSelected == 0) then
			rt_raidNameSelected = nil;
		end
	end

	local movedDown = false;
	if (rt_raidNameSelected) then
		while (rt_raidNameMenuTop + 9 < rt_raidNameSelected) do
			rt_raid_down();
			movedDown = true;
		end
	end
		
	if (not movedDown) then
		rt_raid_down();
	end

	if (rt_raidNameSelected) then
		while (rt_raidNameMenuTop > rt_raidNameSelected) do
			rt_raid_up();
		end
	end
	
	rt_updateRaidNameList();
	rt_updateRaid();
end

function rt_addRaidName(name)
	local newsize = rt_raid["size"] + 1;
	rt_raid["size"] = newsize;
	rt_raid[newsize] = {};
	rt_raid[newsize]["name"] = name;
end

function rt_updateRaidNameList()
	if (rt_raid["size"] == 0) then
		for i=0, 9 do
			local textframe = getglobal("xivenRaidWindowRaidName" .. i+1 .. "Text");
			textframe:SetText("");
		end
		return;
	end
	
	
	--[[
	-- 11 cause new ones can push it over
	if (rt_raidNameMenuTop + 11 > rt_raid["size"]) then
--		rt_raidNameMenuTop = rt_raid["size"] - 10;
	end
	
	if (rt_raidNameMenuTop < 1) then
		rt_raidNameMenuTop = 1;
	end
	]]
	
	if (rt_raidNameSelected) then
		local frame = getglobal("xivenRaidWindowRaidName");
		frame:SetText(rt_raid[rt_raidNameSelected]["name"]);
	end
	
	for i=0, 9 do
		local textframe = getglobal("xivenRaidWindowRaidName" .. i+1 .. "Text");
		if (i + rt_raidNameMenuTop <= rt_raid["size"]) then
			textframe:SetText(rt_raid[i + rt_raidNameMenuTop]["name"]);
			if (rt_raidNameSelected and rt_raidNameSelected == i + rt_raidNameMenuTop) then
				textframe:SetTextColor(1,1,1);
			else
				textframe:SetTextColor(0.9,0.9,0);
			end
		else
			textframe:SetText("");
		end
	end
end

function rt_raid_up()
	rt_raidEscapePressed();
	rt_raidNameMenuTop = rt_raidNameMenuTop - 1;
	if (rt_raidNameMenuTop < 1) then
		rt_raidNameMenuTop = 1;
	end
	
	rt_updateRaidNameList();
end

function rt_raid_down(forceDown)
	rt_raidEscapePressed();
	if (not forceDown and rt_raidNameMenuTop + 10 > rt_raid["size"]) then
		while (rt_raidNameMenuTop + 9 > rt_raid["size"]) do
			rt_raidNameMenuTop = rt_raidNameMenuTop - 1;
			if (rt_raidNameMenuTop < 1) then
				rt_raidNameMenuTop = 1;
				break;
			end
		end
		-- would add unnecessary empty space when you move down
		rt_updateRaidNameList();
		return;
	end
	rt_raidNameMenuTop = rt_raidNameMenuTop + 1;
	if (rt_raidNameMenuTop > rt_raid["size"]) then
		rt_raidNameMenuTop = rt_raid["size"];
	end
	
	rt_updateRaidNameList();
end


function rt_createNewRaid()
	-- show the edit box for creating a new raid
	rt_raidEscapePressed();
	local editBoxLine = rt_raid["size"] - rt_raidNameMenuTop + 2;
	local saver = 1;
--	displayText("editlinebox " .. editBoxLine);
	while (editBoxLine > 10) do
		rt_raid_down(true);
		editBoxLine = rt_raid["size"] - rt_raidNameMenuTop + 2;
		saver = saver + 1;
		if (saver > 50) then
			break;
		end
	end
	
	while (editBoxLine < 1) do
		rt_raid_up();
		editBoxLine = rt_raid["size"] - rt_raidNameMenuTop + 2;
		saver = saver + 1;
		if (saver > 50) then
			break;
		end
	end
	
	local editBox = getglobal("xivenRaidWindowEditBox");
	local frame = getglobal("xivenRaidWindowRaidName" .. editBoxLine);
	editBox:SetPoint("CENTER", frame, "CENTER", 0, 0);
	editBox:Show();
	editBox:SetFocus();
end

function rt_renameRaid()
	rt_raidEscapePressed();
	displayText("NYI");
end

function rt_raidEnterPressed()
	-- actually create (or rename) the raid
	if (not this:IsVisible()) then
		displayText("Edit box wasn't visible. Tell Xiven!");
	end
	local editBox = getglobal("xivenRaidWindowEditBox");
	if (editBox:GetText() == "") then
		return;
	end
	
	local newsize = rt_raid["size"] + 1;
	rt_raid["size"] = newsize;
	rt_raid[newsize] = {};
	rt_raid[newsize]["name"] = editBox:GetText();
	
	local groupCount = {};
	for i=1, 8 do
		groupCount[i] = 0;
	end
	
	local raidCount = GetNumRaidMembers();
	for i = 1, raidCount do
		local name, rank, group, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
		groupCount[group] = groupCount[group] + 1;
		local groupIndex = (group-1)*5 + groupCount[group];
		rt_raid[newsize][groupIndex] = {};
		rt_raid[newsize][groupIndex]["class"] = class;
		rt_raid[newsize][groupIndex]["name"] = name;
	end
		
	for i=1, 40 do
		if (not rt_raid[newsize][i]) then
			rt_raid[newsize][i] = {};
			rt_raid[newsize][i]["class"] = rt_classList[math.random(1, rt_classListSize)];
		end
	end
	
	rt_raid[newsize]["raidsize"] = 40;
	rt_raidNameSelected = newsize;
	rt_raidEscapePressed();
	rt_updateRaidNameList();
	rt_updateRaid();
end

function rt_raidEscapePressed()
	local editBox = getglobal("xivenRaidWindowEditBox");
	editBox:SetText("");
	editBox:ClearFocus();
	editBox:Hide();
end

function rt_setColor (colors, class, r, g, b)
	colors[class] = {};
	colors[class][1] = r;
	colors[class][2] = g;
	colors[class][3] = b;
	return colors;
end

function rt_commands(msg)
	xivenRaidWindow:Show();
	rt_raid["open"] = true;
	
end


function rt_addClass(classes, class, name, id)
	local index = classes[class]["size"] + 1;
	classes[class]["size"] = index;
	classes[class][index] = {};
	classes[class][index]["name"] = name;
	classes[class][index]["class"] = class;
	classes[class][index]["index"] = id;

	return classes;
end

function rt_scrambleArray(array)
	for i=1, 5 do
		local tempRaid = array[i]
		local randNum = math.random(1,5);
		array[i] = array[randNum];
		array[randNum] = tempRaid;
	end

	return array;
end

function rt_raidMethod_checkbox()
	rt_raid["method"] = this:GetID();
	
	for i=1, 2 do
		frame = getglobal("xivenRaidWindow_raidmethod" .. i);
		if (i == rt_raid["method"]) then
			frame:SetChecked(1);
		else	
			frame:SetChecked(0);
		end
	end
end

function rt_scrollbar_onUpdate()
	FauxScrollFrame_Update(this, math.random(1,10), math.random(1,10), math.random(1,10));
end

function empty()
end

function rt_OnUpdate()
	if ( not rt_faction ) then
		rt_updateFunction = empty;
		return;
	end
	
	if (not UnitFactionGroup("player")) then
		return;
	end

	rt_faction = nil;

	if (UnitFactionGroup("player") ~= "Horde") then
		return;
	end
	
	rt_paladinOrShaman = XRT_SHAMAN;
	
	rt_updateRaidNameList();
	rt_updateRaid();
	rt_updateClassPriorityButtons();
	
	local colors = rt_getClassColors();	
	
	rt_classList[8] = rt_paladinOrShaman;
	
	rt_insureClassPriorityIncludesFactionalRace();
	
	for i=1, rt_classListSize do
		local textframe = getglobal("xivenRaidWindowClassName" .. i .. "Text");
		textframe:SetText(rt_classList[i]);
		textframe:SetTextColor(colors[rt_classList[i]][1], colors[rt_classList[i]][2], colors[rt_classList[i]][3]);
	end
end

function rt_insureClassPriorityIncludesFactionalRace()
	-- go through rt_raid and make sure all raids use the right shaman or paladin
	local alternate = XRT_SHAMAN;
	if (rt_paladinOrShaman == XRT_SHAMAN) then
		alternate = XRT_PALADIN;
	end
	
	for i=1, rt_raid["size"] do
		for p=1, rt_raid[i]["raidsize"] do
			if (rt_raid[i][p]["class"] == alternate) then
				rt_raid[i][p]["class"] = rt_paladinOrShaman;
			end
		end
	end

	-- make sure the class priority array exists for this class
	if (rt_raid["classPriority"][rt_paladinOrShaman]) then
		return;
	end

	rt_raid["classPriority"][rt_paladinOrShaman] = {};
	rt_raid["classPriority"][rt_paladinOrShaman]["size"] = 0;
end

function xivenRaidWindow_RaidChange()
	local raidCount = GetNumRaidMembers();

	-- check to see who is new and add them to the classes list
	for i = 1, raidCount do
		local name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
		if (not rt_playerIsInClassPriorityList(name, class)) then
			rt_addPlayerToClassPriorityList(name, class);
		end
	end	
end

function rt_playerIsInClassPriorityList(name, class)
	for i=1, rt_raid["classPriority"][class]["size"] do
		if (rt_raid["classPriority"][class][i] == name) then
			return true;
		end
	end
	return false;
end

function rt_addPlayerToClassPriorityList(name, class)
	local index = rt_raid["classPriority"][class]["size"] + 1;
	rt_raid["classPriority"][class]["size"] = index;
	rt_raid["classPriority"][class][index] = name;
end


function rt_classPriority()
	return rt_raid["class_priority_enabled"];
end

function rt_classPriorityButtonPressed()
	
	local index = rt_raid["class_priority_index"] - 20;
	if (index < 0) then
		index = 0;
	end
	rt_raid["class_priority_index"] = this:GetID() + index;
	rt_updateClassPriorityButtons();
	
end

function rt_updateClassPriorityButtons()
	if (not	rt_selectedClass) then
		return;
	end

	--[[
	if ( <= 20) then
	if (rt_raid["class_priority_index"] <= 20) then
		rt_raid["class_priority_index"] = 20;
		if (rt_raid["class_priority_index"] > rt_raid["classPriority"][rt_selectedClass]["size"]) then
			rt_raid["class_priority_index"]rt_raid["classPriority"][rt_selectedClass]["size"]
	end
	]]

	if (rt_raid["class_priority_index"] > rt_raid["classPriority"][rt_selectedClass]["size"]) then
		rt_raid["class_priority_index"] = rt_raid["classPriority"][rt_selectedClass]["size"];
	end

	if (rt_raid["class_priority_index"] < 1) then
		rt_raid["class_priority_index"] = 1;
	end
	
	local index = rt_raid["class_priority_index"] - 20;
	if (index < 0) then
		index = 0;
	end
	
	local frame = 0;	
	local colors = rt_getClassColors();	
	for i=1, 20 do
		frame = getglobal("xivenRaidWindow_classPriorityButton" .. i .. "Class");

		if (i + index <= rt_raid["classPriority"][rt_selectedClass]["size"]) then
			frame:SetText(rt_raid["classPriority"][rt_selectedClass][i + index]);
			if (i + index == rt_raid["class_priority_index"]) then
				frame:SetTextColor(0,1,0);
			else
				frame:SetTextColor(colors[rt_selectedClass][1], colors[rt_selectedClass][2], colors[rt_selectedClass][3]);
			end
		else
			frame:SetText("");
		end
	end
end

function rt_classPriority_up()
	rt_raid["class_priority_index"] = rt_raid["class_priority_index"] - 1;
	rt_updateClassPriorityButtons();
end

function rt_classPriority_down()
	rt_raid["class_priority_index"] = rt_raid["class_priority_index"] + 1;
	rt_updateClassPriorityButtons();
end

function rt_classPriorityDecrease()
	if (not rt_selectedClass) then
		return;
	end
	
	rt_swapClassPriority(rt_raid["class_priority_index"], rt_raid["class_priority_index"] + 1);
	rt_classPriority_down();
end

function rt_classPriorityIncrease()
	if (not rt_selectedClass) then
		return;
	end
	
	rt_swapClassPriority(rt_raid["class_priority_index"], rt_raid["class_priority_index"] - 1);
	rt_classPriority_up();
end

function rt_swapClassPriority(slot1, slot2)
	if (slot2 > rt_raid["classPriority"][rt_selectedClass]["size"]) then
		return;
	end
	if (slot2 < 1) then
		return;
	end
	
	local temp = rt_raid["classPriority"][rt_selectedClass][slot1];
	rt_raid["classPriority"][rt_selectedClass][slot1] = rt_raid["classPriority"][rt_selectedClass][slot2];
	rt_raid["classPriority"][rt_selectedClass][slot2] = temp;
	rt_updateClassPriorityButtons();
end

function rt_clearNamesAndUsedInRaidResults(array)
	for p=1, rt_classListSize do
		local class = rt_classList[p];
		for i=1, rt_classes[class]["size"] do
			rt_classes[class][i]["used"] = nil;
		end				
	end
end

function rt_hidePriorityButtons()
	getglobal("xivenRaidWindowClassPriorityUp"):Hide();
	getglobal("xivenRaidWindowClassPriorityDown"):Hide();
	getglobal("xivenRaidWindow_classText"):Hide();
	getglobal("xivenRaidWindow_classPriorityIncrease"):Hide();
	getglobal("xivenRaidWindow_classPriorityDecrease"):Hide();
	getglobal("xivenRaidWindow_warning1"):Hide();
	getglobal("xivenRaidWindow_warning2"):Hide();
	getglobal("xivenRaidWindow_warning3"):Hide();
end

function rt_showPriorityButtons()
	getglobal("xivenRaidWindowClassPriorityUp"):Show();
	getglobal("xivenRaidWindowClassPriorityDown"):Show();
	getglobal("xivenRaidWindow_classText"):Show();
	getglobal("xivenRaidWindow_classPriorityIncrease"):Show();
	getglobal("xivenRaidWindow_classPriorityDecrease"):Show();
	getglobal("xivenRaidWindow_warning1"):Show();
	getglobal("xivenRaidWindow_warning2"):Show();
	getglobal("xivenRaidWindow_warning3"):Show();
end

function RIGroupOrderDropDown_Initialize()
	local info;
	for i=1, getn(rt_raid), 1 do
		info = {};
		info.text = rt_raid[i].name;
		info.func = RIGroupOrderDropDownButton_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end


function RIGroupOrderDropDownButton_OnClick()
	UIDropDownMenu_SetSelectedID(RIGroupOrderDropDown, this:GetID());
	rt_raidNameSelected = this:GetID();
	rt_applyButtonPressed();
end









